#ifndef PORT_H_INCLUDED_
#define PORT_H_INCLUDED_

#include "rose.h"

#include "object.h"

namespace risc {

class Port: public Object {

public:

  /**
   * \brief default constructor
   */
  explicit Port(SgVariableDefinition *ast_node, Type type = PortType);

  /**
   * \brief Get function for the name of the ast type of the port
   * \return Name as std::string
   */
  virtual std::string get_ast_type_name();

private:
  /**
   * \brief Disabled copy constructor
   */
  Port(const Port &p);
};

typedef std::vector<Port*> PortVector;
typedef std::vector<Port*>::iterator PortVectorIter;
typedef std::vector<Port*>::const_iterator PortVectorConstIter;

} // end of namespace risc

#endif /* PORT_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
