#ifndef VARIABLE_H_INCLUDED_
#define VARIABLE_H_INCLUDED_

#include <string>
#include <vector>

#include "rose.h"

#include "object.h"

namespace risc {

class Variable;
typedef std::vector<Variable*> VariableVector;
typedef std::vector<Variable*>::iterator VariableVectorIter;
typedef std::vector<Variable*>::const_iterator VariableVectorConstIter;


/**
 * \class Variable
 * \brief This class represents a variable in a module
 */
class Variable: public Object {

public:

  /**
   * \brief default constructor
   */
  explicit Variable(SgVariableDefinition *ast_node);

  /**
   * \brief Returns the type of the variable definition
   * \return type as string
   */
  virtual std::string get_ast_type_name();

private:

  /**
   * \brief Disabled copy constructor
   */
  Variable(const Variable &v);
};

}; // end of namespace risc

#endif /* VARIABLE_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
