#ifndef DATA_CONFLICT_AST_ATTRIBUTES_H_INCLUDED_
#define DATA_CONFLICT_AST_ATTRIBUTES_H_INCLUDED_

#include "rose.h"

namespace risc {

namespace sg {

/**
 * \class DataConflictAstAttributes
 * \brief This class should be used for the data conflict analysis.
 *        We can mark a SgVariableRef instance which has reading or writing
 *        access or is unused.
 */
class DataConflictAstAttributes: public AstAttribute {
public:

  DataConflictAstAttributes();

  enum Status {UNUSED, READ, WRITE};

  Status status_;
};

} // end namespace sg

} // end namespace risc

#endif /* AST_CONFLICT_ATTRIBUTES_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
