#include "vertex_property_writer.h"

#include <boost/algorithm/string.hpp>
#include <string>

risc::sg::VertexPropertyWriter::VertexPropertyWriter(Graph& graph):
  graph_(graph)
{ }

void
risc::sg::VertexPropertyWriter::replace_escape_characters(
    std::string &unparsed_stmt)
{
  boost::algorithm::replace_all(unparsed_stmt, "&",  "&amp;");
  boost::algorithm::replace_all(unparsed_stmt, "\"", "&quot;");
  boost::algorithm::replace_all(unparsed_stmt, "\'", "&#39;");
  boost::algorithm::replace_all(unparsed_stmt, "<",  "&lt;");
  boost::algorithm::replace_all(unparsed_stmt, ">",  "&gt;");
  boost::algorithm::replace_all(unparsed_stmt, "{",  "&#123;");
  boost::algorithm::replace_all(unparsed_stmt, "}",  "&#125;");
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
