#include "search_class_definition_by_name.h"

SgClassDefinition* risc::tools::find_class_definition(std::string class_name,
  std::string qualified_namespace, SgNode* root_node)
{
  // First we try to fiend the native class definition
  std::string class_with_qualifier = qualified_namespace + class_name;

  Rose_STL_Container<SgNode*> class_definitions =
    NodeQuery::querySubTree(root_node, V_SgClassDefinition);

  for(Rose_STL_Container<SgNode*>::iterator
      iter = class_definitions.begin();
      iter != class_definitions.end(); iter++) {

    SgClassDefinition* current_class = isSgClassDefinition(*iter);

    std::string complete_class_namespace = current_class->get_qualified_name();

    if(!complete_class_namespace.compare(class_with_qualifier )){
      return current_class;
    }
  }

  return NULL;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
